/*

 jobterm_c

 Routine to terminate a Job, returns -1 for error.
 Sets errno and _oserr.

 Date		Author		Comments
 ----		------		--------
 06/09/1991	P.J. Taylor	Original.
 15/09/1992	P.J. Taylor	Amended.

 1.04
 ----
 07/03/1998	A.D.Ives	Source code reformatted.

*/

#include <sys/types.h>
#include <errno.h>
#include <qdos.h>
#include <debug.h>

int jobterm(jobid_t jobid) {

  /* jobid	ID of Job that is to be terminated	*/

  errno= 0 ;
  _oserr= 0 ;

  if ( mt_frjob(jobid, -1) )
    errno= EOSERR ;

  if (errno)
    return -1 ;
  else
    return 0 ;
}
